Subject: [OSPF] OSPF GR and BFD operability

From: Anil Raj <[email-masked]>
Date: Tue, 25 Aug 2015 19:49:44 +0530

Hi,

I need clarification on the behavior when BFD notifies remote inactivity
for a OSPF session, when OSPF neighbor is undergoing Graceful restart? OSPF
router in helper mode will ideally inactivate the restarting neighbor only
after grace period, and if BFD notifies neighbor down to OSPF, should the
adjacency be terminated? If not, will it cause a blackhole for the entire
grace period if the neighbor is actually down?

Appreciate if you can help here.

Regards,
Anil

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Tue, 25 Aug 2015 14:53:46 +0000

Hi Anil,

OSPF and OSPFv3 graceful restart pre-dated BFD so this wasn’t explicitly covered. However, given that the intension is that the data plane is preserved during restart, an implementation could interpret this as a topology change and terminate helper mode as documented in section 3.2 of RFC 3623.
Hope this helps,
Acee

From: OSPF <[email-masked]<mailto:[email-masked]>> on behalf of Anil Raj <[email-masked]<mailto:[email-masked]>>
Date: Tuesday, August 25, 2015 at 10:19 AM
To: OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: [OSPF] OSPF GR and BFD operability

Hi,

I need clarification on the behavior when BFD notifies remote inactivity for a OSPF session, when OSPF neighbor is undergoing Graceful restart? OSPF router in helper mode will ideally inactivate the restarting neighbor only after grace period, and if BFD notifies neighbor down to OSPF, should the adjacency be terminated? If not, will it cause a blackhole for the entire grace period if the neighbor is actually down?

Regards,
Anil

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Tue, 25 Aug 2015 15:27:59 +0000

https://www.rfc-editor.org/rfc/rfc5882.txt Section 4.3<https://www.rfc-editor.org/rfc/rfc5882.txt%20Section%204.3> is relevant here.

   Les

From: OSPF [mailto:[email-masked]] On Behalf Of Acee Lindem (acee)
Sent: Tuesday, August 25, 2015 7:54 AM
To: Anil Raj; OSPF WG List
Subject: Re: [OSPF] OSPF GR and BFD operability

Hi Anil,

Hi,

Regards,
Anil

---

From: Anil Raj <[email-masked]>
Date: Tue, 25 Aug 2015 21:06:32 +0530

Thanks Acee for the details.
My concern was also in regards that, in a BFD-less setup during
helper-mode, OSPF hello packets from the neighbor are not honored at all
and is not used as a heartbeat mechanism, and hence waits for the entire
grace period before announcing the peer down. So any BFD implementation
done on software (may be multi-hop peers if applicable), this may still
cause BFD to cause remote inactivity notification, with data plane still
intact.

Regards,
Anil

On Tue, Aug 25, 2015 at 8:23 PM, Acee Lindem (acee) <[email-masked]> wrote:

> Hi Anil,
>
> OSPF and OSPFv3 graceful restart pre-dated BFD so this wasn’t explicitly
> covered. However, given that the intension is that the data plane is
> preserved during restart, an implementation could interpret this as a
> topology change and terminate helper mode as documented in section 3.2 of
> RFC 3623.
> Hope this helps,
> Acee
>
>
>
> From: OSPF <[email-masked]> on behalf of Anil Raj <
> [email-masked]>
> To: OSPF WG List <[email-masked]>

---

From: Anil Raj <[email-masked]>
Date: Tue, 25 Aug 2015 21:21:00 +0530

Thanks Acess, Les.

So ideally it is recommended to tear down OSPF adjacency and signal
topology change, and thus honor BFD notification in this case.

Regards,
Anil

On Tue, Aug 25, 2015 at 8:57 PM, Les Ginsberg (ginsberg) <[email-masked]
> wrote:

> https://www.rfc-editor.org/rfc/rfc5882.txt Section 4.3 is relevant here.
>
>
>
>    Les
>
>
>
>
>
> *From:* OSPF [mailto:[email-masked]] *On Behalf Of *Acee Lindem
> (acee)
> *Sent:* Tuesday, August 25, 2015 7:54 AM
> *To:* Anil Raj; OSPF WG List
> *Subject:* Re: [OSPF] OSPF GR and BFD operability
>
>
>
> Hi Anil,
>
>
>
> *From: *OSPF <[email-masked]> on behalf of Anil Raj <
> [email-masked]>
> *Date: *Tuesday, August 25, 2015 at 10:19 AM
> *To: *OSPF WG List <[email-masked]>
> *Subject: *[OSPF] OSPF GR and BFD operability
>
>
>
> Hi,
>
>
>

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Tue, 25 Aug 2015 16:29:23 +0000

Anil –

IF BFD does NOT share fate w the Control plane then what you say is true.

If BFD shares fate w the control plane then the behavior depends on the neighbor knowing that a restart is in progress. If neighbor knows this then the BFD down event can be ignored w minimal risk – otherwise you need to treat it as a real failure.

   Les

From: Anil Raj [mailto:[email-masked]]
Sent: Tuesday, August 25, 2015 8:51 AM
To: Les Ginsberg (ginsberg)
Cc: Acee Lindem (acee); OSPF WG List
Subject: Re: [OSPF] OSPF GR and BFD operability

Thanks Acess, Les.

So ideally it is recommended to tear down OSPF adjacency and signal topology change, and thus honor BFD notification in this case.

Regards,
Anil

On Tue, Aug 25, 2015 at 8:57 PM, Les Ginsberg (ginsberg) <[email-masked]<mailto:[email-masked]>> wrote:
https://www.rfc-editor.org/rfc/rfc5882.txt Section 4.3<https://www.rfc-editor.org/rfc/rfc5882.txt%20Section%204.3> is relevant here.

   Les

From: OSPF [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Acee Lindem (acee)
Sent: Tuesday, August 25, 2015 7:54 AM
To: Anil Raj; OSPF WG List
Subject: Re: [OSPF] OSPF GR and BFD operability

Hi Anil,

Hi,

Regards,
Anil

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Tue, 25 Aug 2015 16:41:50 +0000

I agree. Thanks Les for the reference to RFC 5882.

Thanks,
Acee

From: "Les Ginsberg (ginsberg)" <[email-masked]<mailto:[email-masked]>>
Date: Tuesday, August 25, 2015 at 12:29 PM
To: Anil Raj <[email-masked]<mailto:[email-masked]>>
Cc: Acee Lindem <[email-masked]<mailto:[email-masked]>>, OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: RE: [OSPF] OSPF GR and BFD operability

Anil –

   Les

Thanks Acess, Les.

Regards,
Anil

   Les

Hi Anil,

Hi,

Regards,
Anil

---

From: Anil Raj <[email-masked]>
Date: Wed, 26 Aug 2015 08:37:55 +0530

I got it. Thanks Les for the details and reference.

Regards,
Anil

On Tue, Aug 25, 2015 at 10:11 PM, Acee Lindem (acee) <[email-masked]> wrote:

> From: "Les Ginsberg (ginsberg)" <[email-masked]>
> To: Anil Raj <[email-masked]>
> Cc: Acee Lindem <[email-masked]>, OSPF WG List <[email-masked]>
> If BFD shares fate w the control plane then the behavior depends on the
> neighbor knowing that a restart is in progress. If neighbor knows this then
> the BFD down event can be ignored w minimal risk – otherwise you need to
> treat it as a real failure.
>
>
>
>    Les
>
>
>
>
>
> *From:* Anil Raj [mailto:[email-masked] <[email-masked]>]
> *Sent:* Tuesday, August 25, 2015 8:51 AM
> *To:* Les Ginsberg (ginsberg)
> *Cc:* Acee Lindem (acee); OSPF WG List
> On Tue, Aug 25, 2015 at 8:57 PM, Les Ginsberg (ginsberg) <
> [email-masked]> wrote:
>
> https://www.rfc-editor.org/rfc/rfc5882.txt Section 4.3
> <https://www.rfc-editor.org/rfc/rfc5882.txt%20Section%204.3> is relevant
> here.
>
>
>
>    Les
>
>
>
>
>